@echo off
rem This script scans through all the ticket attachments creating an MD5 hash
rem it then removes duplicate entries and copies a unique list of attachments
rem to a sub folder named "00-to-delete" within the current folder.

cls

ECHO There are 5 steps to this process
ECHO.
ECHO 1.   Setting up required folders
IF EXIST 00-to-delete\. rd 00-to-delete /S /Q
md 00-to-delete
md 00-to-delete\unwanted

Echo 2.   Create list of MD5's for every attachment, be patient this may take a little time
"..\..\..\..\bin\ruby" GenerateMD5s.rb ..\..\ticket\ filelist.txt

rem we need to remove dup files from the list to make the review easier
ECHO 3.   Sorting file list
sort filelist.txt /o filelistsorted.txt

del filelist.txt

set PrevBytes=0
set PrevHash=0

ECHO 4.   Analysing list and copying non duplicate files for review, be patient this may take a little time
FOR /F "tokens=1,2*" %%G IN (filelistsorted.txt) DO call :PrepFileReview %%G %%H "%%I"

del filelistsorted.txt

ECHO 5.   Finished processing files, you can now start the file selection process.
goto :eof

:PrepFileReview
set Bytes=%1%
set hash=%2%
set Fullname=%3

IF NOT %Bytes% == %PrevBytes% GOTO :DiffByHa
IF NOT %hash%  == %PrevHash%  GOTO :DiffByHa

Rem size and hash match the previous entry so ignore as its the same file

goto :eof

:DiffByHa
Rem Bytes or hash don't match so we need to copy file to viewing area "00-to-delete"
rem no need to add code to make filename unique as it already is due to spice works naming convention

copy %Fullname% 00-to-delete\ > nul:

set PrevBytes=%Bytes%
set PrevHash=%hash%

goto :eof
